unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ARERegistryVariable, ComCtrls;

type
  TfrmMain = class(TForm)
    BTN_Ok: TButton;
    REG_Text: TARERegistryVariable;
    LAB_Information: TLabel;
    EDT_Text: TEdit;
    RBT_Yes: TRadioButton;
    RBT_No: TRadioButton;
    DAP_Date: TDateTimePicker;
    REG_Yes: TARERegistryVariable;
    REG_Date: TARERegistryVariable;
    procedure FormShow(Sender: TObject);
    procedure BTN_OkClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure REG_DateError(Sender: TObject;
      ErrorType: TARERegistryErrorType; Param: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation


{$R *.DFM}


procedure TfrmMain.FormShow(Sender: TObject);
begin
	{Read Values Safely by Reading them with ReadDef.. if the value does not exist then the def value is aplicated.. like IntToStrDef for example}
	{If writeonDef is true the variable is automitacly wroten once is readed with ReadDef}
	
	EDT_Text.Text := REG_Text.ReadDef('Enter Any Text...');
	RBT_Yes.Checked := REG_Yes.ReadDef(True);
	RBT_No.Checked := not REG_Yes.Read;
	DAP_Date.Date := REG_Date.ReadDef(Now);
end;

procedure TfrmMain.BTN_OkClick(Sender: TObject);
begin
	Close;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	{Store the values so next time they are updated}
	REG_Text.Write(EDT_Text.Text);
	REG_Yes.Write(RBT_Yes.Checked);
	REG_Date.Write(DAP_Date.Date);
end;

procedure TfrmMain.FormKeyPress(Sender: TObject; var Key: Char);
begin
	if Key = #13 then
		begin
			Key := #0;
			SelectNext(ActiveControl as TWinControl,True,True);
		end;
end;

procedure TfrmMain.REG_DateError(Sender: TObject;ErrorType: TARERegistryErrorType; Param: String);
begin
	case ErrorType of
		ERR_Read_KeyNotFound:
			begin
				ShowMessage(Format('Can''t Read Key %s, It does not exist',[Param]));
			end;
		ERR_Read_ValueNotFound:
			begin
				ShowMessage(Format('Can''t Read Value %s, It does not exist',[Param]));			
			end;
		ERR_Write_KeyNotFound:
			begin
				{This actually should never happen... because on writing the variables the keys are created.. but... We never now...}
				ShowMessage(Format('Can''t Value Key %s, It does not exist',[Param]));
			end;
		ERR_Write_Value:
			begin
				ShowMessage(Format('Can''t Write Value %s, Some Error happened trying to write at the registry',[Param]));
			end;
		ERR_Delete_KeyNotFound:
			begin
				ShowMessage(Format('Can''t Delete Value. The Key %s, It does not exits',[Param]));
			end;
		ERR_Delete_ValueNotFound:
			begin
				ShowMessage(Format('Can''t Delete Value %s, It does not exits',[Param]));
			end;
	end;

end;

end.
